# Copyright (c) 2002 Gavin Brown. All rights reserved. This program is
# free software; you can redistribute it and/or modify it under the same
# terms as Perl itself. 
#
# $Id: Hours.pm,v 1.1 2002/11/27 14:57:56 jodrell Exp $

package Gnome::Crontab::Hours;

sub new {
	my ($class, $gc, $value) = @_;
	my $gcm = {};
	bless($gcm, $class);

	if ($value =~ /\*/) {
		$gcm->{wildcard} = 1;
	} else {
		foreach my $hour (split(/,/, $value)) {
			$hour = sprintf('%02d', $hour);
			$gcm->{values}{$hour} = 1;
		}
	}

	$gcm->{widget} = Gtk::Table->new(13, 3);
	$gcm->{widget}->set_row_spacings(8);
	$gcm->{widget}->set_col_spacings(8);
	$gcm->{widget}->attach_defaults($gc->label('hours_info'), 0, 1, 0, 1);
	my $row    = 0;
	my $column = 1;
	for ($i = 0 ; $i < 24 ; $i++) {
		if ($i == 12) {
			$row    = 1;
			$column = 1;
		}
		my $hour = sprintf('%02d', $i);
		$gcm->{checkboxes}{$hour} = Gtk::CheckButton->new($hour);
		$gcm->{checkboxes}{$hour}->set_active(1) if ($gcm->{values}{$hour} == 1 || $gcm->{wildcard} == 1);
		$gcm->{checkboxes}{$hour}->signal_connect('toggled', sub { $gcm->hour_toggle($hour) });
		$gcm->{widget}->attach_defaults($gcm->{checkboxes}{$hour}, $column, $column+1, $row, $row+1);
		$column++;
	}

	$gcm->{toggle} = Gtk::CheckButton->new($gc->string('select_all'));
	$gcm->{toggle}->set_active(1) if ($gcm->{wildcard} == 1);

	$gcm->{toggle}->signal_connect('toggled', sub { $gcm->select_all_toggle($gc) });

	$gcm->{widget}->attach_defaults($gcm->{toggle}, 1, 13, 2, 3);

	return $gcm;
}

sub hour_toggle {
	my ($gcm, $hour) = @_;

	if (!$gcm->{checkboxes}{$hour}->get_active()) {
		undef $gcm->{wildcard};
		$gcm->{toggle}->set_active(0);
	}

	return;
}

sub select_all_toggle {
	my ($gcm, $gc) = @_;
	if ($gcm->{toggle}->get_active()) {
		for ($i = 0 ; $i < 24 ; $i++) {
			my $hour = sprintf('%02d', $i);
			$gcm->{checkboxes}{$hour}->set_active(1);
		}
		$gcm->{wildcard} = 1;
	}
	return;
}

sub value {
	my $gcm = shift;
	if ($gcm->{wildcard} == 1) {
		return '*';
	} else {
		my @return;
		for ($i = 0 ; $i < 24 ; $i++) {
			my $hour = sprintf('%02d', $i);
			push(@return, $hour) if ($gcm->{checkboxes}{$hour}->get_active());
		}
		return join(',', sort(@return));
	}
}

1;