# Copyright (c) 2002 Gavin Brown. All rights reserved. This program is
# free software; you can redistribute it and/or modify it under the same
# terms as Perl itself. 
#
# $Id: Minutes.pm,v 1.2 2002/11/27 14:57:56 jodrell Exp $

package Gnome::Crontab::Minutes;

sub new {
	my ($class, $gc, $value) = @_;
	my $gcm = {};
	bless($gcm, $class);

	$gcm->{widget} = Gtk::Table->new(2, 2, 0);

	$gcm->{radio}{multiple} = Gtk::RadioButton->new($gc->string('minutes_multiple'));
	$gcm->{radio}{interval} = Gtk::RadioButton->new($gc->string('minutes_interval'), $gcm->{radio}{multiple});
	$gcm->{radio}{wildcard} = Gtk::RadioButton->new($gc->string('minutes_wildcard'), $gcm->{radio}{multiple});

	$gcm->{input} = Gtk::Entry->new();

	$gcm->{interval} = Gtk::Combo->new();
	$gcm->{interval}->set_popdown_strings(
		$gc->string('interval_5'),
		$gc->string('interval_10'),
		$gc->string('interval_20'),
		$gc->string('interval_30'),
	);
	$gcm->{interval}->disable_activate();
	$gcm->{interval}->entry()->set_editable(0);

	$gcm->{widget}->attach_defaults($gcm->{radio}{multiple},		0, 1, 0, 1);
	$gcm->{widget}->attach_defaults($gcm->{input},				1, 2, 0, 1);

	$gcm->{widget}->attach_defaults($gcm->{radio}{interval},		0, 1, 1, 2);
	$gcm->{widget}->attach_defaults($gcm->{interval},			1, 2, 1, 2);

	$gcm->{widget}->attach_defaults($gcm->{radio}{wildcard},		0, 1, 2, 3);
	$gcm->{widget}->attach_defaults(Gtk::Label->new(),			1, 2, 2, 3);

	if ($value =~ /\*/) {
		$gcm->{radio}{wildcard}->set_active(1);
	} elsif ($value =~ /^\/(\d{1,2})/) {
		$gcm->{radio}{interval}->set_active(1);
		$gcm->{interval}->entry()->set_text(sprintf($gc->string('interval_n', $1)));
	} else {
		$gcm->{radio}{multiple}->set_active(1);
		$gcm->{input}->set_text($value);
	}

	return $gcm;
}

sub value {
	my $gcm = shift;
	if ($gcm->{radio}{wildcard}->get_active()) {
		return '*';
	} elsif ($gcm->{radio}{interval}->get_active()) {
		my $value = $gcm->{interval}->entry()->get_text();
		$value =~ s/[^0-9]//g;
		return "/$value";
	} else {
		my $value = $gcm->{input}->get_text();
		$value =~ s/[^0-9\,]//g;
		return $value;
	}
}

1;