# Copyright (c) 2002 Gavin Brown. All rights reserved. This program is
# free software; you can redistribute it and/or modify it under the same
# terms as Perl itself. 
#
# $Id: Months.pm,v 1.1 2002/11/28 09:05:53 jodrell Exp $

package Gnome::Crontab::Months;

sub new {
	my ($class, $gc, $value) = @_;
	my $gcm = {};
	bless($gcm, $class);

	if ($value =~ /\*/) {
		$gcm->{wildcard} = 1;
	} else {
		foreach my $month (split(/,/, $month)) {
			$gcm->{values}{$month} = 1;
		}
	}

	$gcm->{gc} = $gc;

	$gcm->{widget} = Gtk::Table->new(6, 3);
	$gcm->{widget}->set_row_spacings(8);
	$gcm->{widget}->set_col_spacings(8);
	my $row    = 0;
	my $column = 0;
	foreach my $month (qw(jan feb mar apr may jun jul aug sep oct nov dec)) {
		my $month = $gc->string($month);
		if ($column == 6) {
			$row    = 1;
			$column = 0;
		}
		$gcm->{checkboxes}{$month} = Gtk::CheckButton->new($month);
		$gcm->{checkboxes}{$month}->set_active(1) if ($gcm->{values}{$month} == 1 || $gcm->{wildcard} == 1);
		$gcm->{checkboxes}{$month}->signal_connect('toggled', sub { $gcm->month_toggle($month) });
		$gcm->{widget}->attach_defaults($gcm->{checkboxes}{$month}, $column, $column+1, $row, $row+1);
		$column++;
	}

	$gcm->{toggle} = Gtk::CheckButton->new($gc->string('select_all'));
	$gcm->{toggle}->set_active(1) if ($gcm->{wildcard} == 1);

	$gcm->{toggle}->signal_connect('toggled', sub { $gcm->select_all_toggle() });

	$gcm->{widget}->attach_defaults($gcm->{toggle}, 0, 6, 2, 3);

	return $gcm;
}

sub month_toggle {
	my ($gcm, $month) = @_;
	if (!$gcm->{checkboxes}{$month}->get_active()) {
		undef $gcm->{wildcard};
		$gcm->{toggle}->set_active(0);
	}

	return;
}

sub select_all_toggle {
	my $gcm = shift;
	if ($gcm->{toggle}->get_active()) {
		foreach (qw(jan feb mar apr may jun jul aug sep oct nov dec)) {
			my $month = $gcm->{gc}->string($_);
			$gcm->{checkboxes}{$month}->set_active(1);
		}
		$gcm->{wildcard} = 1;
	}
	return;
}

sub value {
	my $gcm = shift;
	if ($gcm->{wildcard} == 1) {
		return '*';
	} else {
		my @return;
		foreach (qw(jan feb mar apr may jun jul aug sep oct nov dec)) {
			my $month = $gcm->{gc}->string($_);
			push(@return, $month) if ($gcm->{checkboxes}{$month}->get_active());
		}
		return lc(join(',', @return));
	}
}

1;